summaryrefslogtreecommitdiff
path: root/scripts/git-submodule.sh
diff options
context:
space:
mode:
authorDaniel P. Berrange <berrange@redhat.com>2017-09-29 11:11:56 +0100
committerGerd Hoffmann <kraxel@redhat.com>2017-10-16 14:46:44 +0200
commitaef45d51d1204f3335fb99de6658e0c5612c2b67 (patch)
tree3dd65cf0fd7f685cfd245e6f14f591f53de24126 /scripts/git-submodule.sh
parentf90ea7ba7c5ae7010ee0ce062207ae42530f57d6 (diff)
downloadqemu-aef45d51d1204f3335fb99de6658e0c5612c2b67.tar.gz
build: automatically handle GIT submodule checkout for dtc
Currently if DTC is required by configure and not available in the host OS install, we exit with an error message telling the user to checkout a git submodule or install the library. This introduces automatic handling of the git submodule checkout process and enables it for dtc. This only runs if building from GIT, so users of release tarballs still need the system library install. The current state of the git checkout is stashed in .git-submodule-status, and a helper program is used to determine if this state matches the desired submodule state. A dependency against 'Makefile' ensures that the submodule state is refreshed at the start of the build process Signed-off-by: Daniel P. Berrange <berrange@redhat.com> Message-id: 20170929101201.21039-2-berrange@redhat.com [ kraxel: use /bin/sh not bash for scripts/git-submodule.sh ] [ kraxel: fix Makefile dependencies ] Signed-off-by: Gerd Hoffmann <kraxel@redhat.com> [fixup] Makefile dep
Diffstat (limited to 'scripts/git-submodule.sh')
-rwxr-xr-xscripts/git-submodule.sh38
1 files changed, 38 insertions, 0 deletions
diff --git a/scripts/git-submodule.sh b/scripts/git-submodule.sh
new file mode 100755
index 0000000000..d8fbc7e47e
--- /dev/null
+++ b/scripts/git-submodule.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+#
+# This code is licensed under the GPL version 2 or later. See
+# the COPYING file in the top-level directory.
+
+set -e
+
+substat=".git-submodule-status"
+
+command=$1
+shift
+modules="$@"
+
+if test -z "$modules"
+then
+ test -e $substat || touch $substat
+ exit 0
+fi
+
+if ! test -e ".git"
+then
+ echo "$0: unexpectedly called with submodules but no git checkout exists"
+ exit 1
+fi
+
+case "$command" in
+status)
+ test -f "$substat" || exit 1
+ trap "rm -f ${substat}.tmp" EXIT
+ git submodule status $modules > "${substat}.tmp"
+ diff "${substat}" "${substat}.tmp" >/dev/null
+ exit $?
+ ;;
+update)
+ git submodule update --init $modules 1>/dev/null 2>&1
+ git submodule status $modules > "${substat}"
+ ;;
+esac